﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using MindFusion.Diagramming;
using System.IO;
using System.Drawing;

/// <summary>
/// Summary description for DecisionDiagramHelper
/// </summary>
public class DecisionDiagramHelper
{
   
       #region member variables
        MindFusion.Drawing.LinearGradientBrush decisionBrush;
        MindFusion.Drawing.LinearGradientBrush terminalBrush;
        MindFusion.Drawing.LinearGradientBrush StartterminalBrush;
        MindFusion.Drawing.Pen terminalPen;
        MindFusion.Drawing.LinearGradientBrush normalBrush;
        MindFusion.Drawing.LinearGradientBrush documentBrush;

        MindFusion.Drawing.SolidBrush linkNormalBrush;
        MindFusion.Drawing.SolidBrush linkCuruntPathBrush;


        DiagramLink link;
        List<DiagramList> allDiagramList = new List<DiagramList>();
        int ddlTreeType = 0;
        string ddlDiagramSize = string.Empty;
        int decisionType = 0;
        MindFusion.Diagramming.WebForms.DiagramView diagramView;
        //DecisionTreeFacade facade = new DecisionTreeFacade();
        int hdnArragePosition = 0;
        ArrayList arrList = new ArrayList();
        int indx = 1;
        #endregion
        #region LoadFusion 
        /// <summary>
        /// Used to load process flow diagram and question with answer and score in Decision Tree.
        /// </summary>
        /// <param name="diagramView1">object</param>
        /// <param name="lstQuestionAction">list of class object</param>
        /// <param name="decisionTypeId">integer</param>
        /// <param name="lstSections">list</param>
        /// <param name="treeType">integer</param>
        /// <param name="diagramSize">string</param>
        /// <param name="arragePosition">integer</param>
        /// <param name="viewBy">integer</param>
        /// <param name="arrEndNodeList">out parameter object</param>
        /// <param name="from">integer</param>
        /// <returns> Return the numeric value</returns>
        public int LoadFusion(MindFusion.Diagramming.WebForms.DiagramView diagramView1, List<DecisionTree> lstQuestionAction, int decisionTypeID, int version, List<DecisionTree> lstSections, int treeType, string diagramSize, int arragePosition, int viewBy, out ArrayList arrEndNodeList, int from = 0, int diagrampagesize = 100, int indexScore = 0, List<DecisionTree> lstDecisonRule = null)
        {
            try
            {
                hdnArragePosition = arragePosition;
                diagramView = diagramView1;
                ddlTreeType = treeType;
                ddlDiagramSize = diagramSize;
                decisionType = decisionTypeID;
                #region 
                var diagram = diagramView.Diagram;
                diagramView.LicenseKey = "AQAAADcAAAAoAAAAAQAACh8IqZ6TuJqRmoyWjLKWkZu5ioyWkJHRu5aemI2ekpKWkZjRqJqduZCNkoz/P2rAciws95KTgC1bsPX3M3B8jNKrczf0bM/iQdJzgjoRMr1WCBbYsBTTFt6+H0s=";
                diagramView.ImageFormat = "image/png";

                StartterminalBrush = new MindFusion.Drawing.LinearGradientBrush(
                Color.FromArgb(0xF0, 0xFF, 0xFF), Color.FromArgb(0x7F, 0xDF, 0x8F), 90);
                terminalBrush = new MindFusion.Drawing.LinearGradientBrush(
                Color.FromArgb(253, 247, 245), Color.FromArgb(255, 205, 191), 90);
                decisionBrush = new MindFusion.Drawing.LinearGradientBrush(
                Color.FromArgb(0xFF, 0xFF, 0xC0), Color.FromArgb(0xBF, 0xBF, 0x90), 90);
                documentBrush = new MindFusion.Drawing.LinearGradientBrush(
                Color.FromArgb(233, 234, 254), Color.FromArgb(230, 230, 252), 90);
                normalBrush = new MindFusion.Drawing.LinearGradientBrush(
                Color.FromArgb(0xE0, 0xFF, 0xFF), Color.FromArgb(0xA8, 0xBF, 0xBF), 90);
                linkCuruntPathBrush = new MindFusion.Drawing.SolidBrush(
                Color.FromArgb(0, 102, 23));
                linkNormalBrush = new MindFusion.Drawing.SolidBrush(
                Color.FromArgb(240, 240, 240));
                terminalPen = new MindFusion.Drawing.Pen(Color.Black) { Width = 0.3f };
                diagram.DiagramStyle.ShadowBrush = new MindFusion.Drawing.SolidBrush(Color.FromArgb(0x6E, Color.Black));
                diagram.DiagramStyle.FontFamily = "Segoe UI";
                diagram.DiagramStyle.FontStyle = FontStyle.Regular;
                diagram.DiagramStyle.FontSize = 8;
                diagram.ShadowOffsetX = 2;
                diagram.ShadowOffsetY = 2;
                diagram.DiagramLinkStyle.ShadowBrush = new MindFusion.Drawing.SolidBrush(Color.Transparent);
                diagram.DiagramLinkStyle.TextBrush = new MindFusion.Drawing.SolidBrush(Color.FromArgb(0x00, 0x00, 0x8B));
                diagram.DiagramLinkStyle.FontStyle = FontStyle.Bold;
                diagram.LinkHeadShape = ArrowHeads.PointerArrow;
                diagram.LinkHeadShapeSize = 3.5f;

                //=====================================
                diagram.RoundedLinks = true;
                diagram.RouteLinks = true;
                diagram.AutoHighlightRows = true;
                diagram.RoundedLinksRadius = 20;
                diagram.LinkCrossings = LinkCrossings.Arcs;
                diagram.RoutingOptions.Anchoring = Anchoring.Keep;
                diagram.RoutingOptions.TurnCost = 10;
                diagram.RoutingOptions.CrossingCost = 5;
                diagram.RoutingOptions.LengthCost = 10;
                diagram.RoutingOptions.NodeVicinityCost = 10;
                diagram.RoutingOptions.NodeVicinitySize = 42;
                diagram.RoutingOptions.StartOrientation = MindFusion.Diagramming.Orientation.Horizontal;
                diagram.RoutingOptions.EndOrientation = MindFusion.Diagramming.Orientation.Vertical;
                #endregion

                lstQuestionAction.ForEach(x => { x.NodeStatus = 0; });
                diagramView.Diagram.ClearAll();
                if (lstQuestionAction.Any())
                {
                    if (viewBy == 0 || viewBy == 1)
                    {
                        var startNode = diagramView.Diagram.Factory.CreateShapeNode(0, 0, ddlTreeType == 0 ? 30 : 20, 10);
                        startNode.Font = new Font("Arial Unicode MS", 8.5F, FontStyle.Regular);
                        startNode.Brush = StartterminalBrush;
                        startNode.Pen = terminalPen;
                        startNode.Text = "Start";
                        startNode.Tag = "start";
                        startNode.Shape = Shapes.Ellipse;
                        var newNode = diagramView.Diagram.Factory.CreateShapeNode(0, (lstQuestionAction.Count + 1) * 7, ddlTreeType == 0 ? 50 : 25, ddlTreeType == 0 ? 30 : 20);
                        newNode.Shape = Shapes.Decision;
                        newNode.AnchorPattern = AnchorPattern.TopInBottomOut;
                        newNode.Brush = decisionBrush;
                        newNode.TextPadding = new Thickness { Top = 5, Right = 5, Left = 5 };
                        newNode.Font = new Font("Arial Unicode MS", 8.5F, FontStyle.Regular);
                        newNode.Text = from == 0 ? HttpUtility.HtmlDecode(ddlTreeType == 0 ? lstQuestionAction.Where(x => x.Step == 1).ToList()[0].QuestionsRoot : lstQuestionAction.Where(x => x.Step == 1).ToList()[0].QuestionRootNode) : HttpUtility.HtmlDecode(ddlTreeType == 0 ? lstQuestionAction.Where(x => x.Step == 1).ToList()[0].QuestionsRoot : lstQuestionAction.Where(x => x.Step == 1).ToList()[0].QuestionIDRoot.ToString());
                        if (newNode.Text.Trim().Length > 75)
                        {
                            newNode.Text = HttpUtility.HtmlDecode(newNode.Text.Substring(0, 75)) + "...";
                        }
                        newNode.ToolTip = from == 0 ? lstQuestionAction.Where(x => x.Step == 1).ToList()[0].QuestionsRoot : HttpUtility.HtmlDecode(lstQuestionAction.Where(x => x.Step == 1).ToList()[0].QuestionsRoot);
                        newNode.GetToolTip(new PointF(newNode.Bounds.X, newNode.Bounds.Y));
                        newNode.Tag = lstQuestionAction.Where(x => x.Step == 1).ToList()[0].QuestionIDRoot +"Q" + "-0";
                        allDiagramList.Add(new DiagramList { NodeTag = newNode.Tag.ToString(), DecisionParent = "0", QuestionID = lstQuestionAction.Where(x => x.Step == 1).ToList()[0].QuestionIDRoot, RNo = allDiagramList.Count() });
                        link = diagramView.Diagram.Factory.CreateDiagramLink(startNode, newNode);
                        SetLikStyle(link, lstQuestionAction.Exists(x => x.Step == 1 && x.IsConduct == 1) ? 1 : 0);
                        link.CrossingRadius = 10;
                        LoadFusionChild(lstQuestionAction.Where(x => x.Step == 1).ToList()[0].QuestionIDRoot, 0, "0", lstQuestionAction, newNode, normalBrush, decisionBrush, from, indexScore, version);
                        Arrange(allDiagramList);
                    }
                   
                }
                arrEndNodeList = arrList;
                return hdnArragePosition;
            }
            catch (Exception ex)
            {
               // ex.Write();
                throw ex;
            }
        }
        #endregion
        #region LoadFusionChild
        /// <summary>
        /// Used to load process flow diagram and question with answer and score.
        /// </summary>
        /// <param name="rootID">integer</param>
        /// <param name="parentID">integer</param>
        /// <param name="parentDecision">string</param>
        /// <param name="lstQuestionAction">list of class object</param>
        /// <param name="newNode">ShapeNode</param>
        /// <param name="normalBrush">LinearGradientBrush</param>
        /// <param name="decisionBrush">LinearGradientBrush</param>
        public void LoadFusionChild(int rootID, int parentID, string parentDecision, List<DecisionTree> lstQuestionAction, ShapeNode newNode, MindFusion.Drawing.LinearGradientBrush normalBrush, MindFusion.Drawing.LinearGradientBrush decisionBrush, int from, int indexScore, int version)
        {
            var lstdistinct = lstQuestionAction.Where(x => x.QuestionIDRoot == rootID && x.PrvQuestionID == parentID && x.ParentDecision == (parentID != 0 ? parentID + "-" + parentDecision : "0") && x.NodeStatus == 0).ToList().Select(x => new { QuestionIDRoot = x.QuestionIDRoot, QuestionID = x.QuestionID, PrvQuestionID = x.PrvQuestionID, ParentDecision = x.ParentDecision }).ToList()
                .GroupBy(X => new
                {
                    X.QuestionIDRoot,
                    X.QuestionID,
                    X.PrvQuestionID,
                    X.ParentDecision
                }).Select(s => s.FirstOrDefault()).ToList();


            foreach (var disItem in lstdistinct)
            {
                if (disItem.QuestionID != 0)
                {
                    var lstByGrouping =
                        lstQuestionAction.Where(
                            x =>
                                x.QuestionIDRoot == disItem.QuestionIDRoot && x.QuestionID == disItem.QuestionID &&
                                x.ParentDecision == disItem.ParentDecision).ToList();
                    ShapeNode newNodeAction;


                    if (
                        allDiagramList.Exists(
                            x =>
                                x.QuestionID == lstByGrouping[0].QuestionID &&
                                x.QuestionIDRoot == lstByGrouping[0].QuestionIDRoot &&
                                x.DecisionParent == lstByGrouping[0].ParentDecision))
                    {
                        newNodeAction =
                            diagramView.Diagram.FindNode(
                                allDiagramList.Where(
                                    x =>
                                        x.QuestionID == lstByGrouping[0].QuestionID &&
                                        x.QuestionIDRoot == lstByGrouping[0].QuestionIDRoot).ToList()[0].NodeTag) as
                                ShapeNode;
                    }
                    else if (
                        allDiagramList.Exists(
                            x =>
                                x.QuestionID == lstByGrouping[0].QuestionID &&
                                lstQuestionAction.Exists(
                                    Ex => Ex.QuestionIDRoot == lstByGrouping[0].QuestionID && Ex.PrvQuestionID == 0)))
                    {
                        newNodeAction =
                            diagramView.Diagram.FindNode(
                                allDiagramList.Where(
                                    x => x.QuestionID == lstByGrouping[0].QuestionID && x.PrvQuestionID == 0)
                                    .ToList()[0].NodeTag) as ShapeNode;
                    }
                    else
                    {
                        newNodeAction = diagramView.Diagram.Factory.CreateShapeNode(0, 0, ddlTreeType == 0 ? 50 : 25,
                            ddlTreeType == 0 ? 30 : 20);
                        newNodeAction.Shape = Shapes.Decision;
                        newNodeAction.TextPadding = new Thickness { Top = 5, Left = 5, Right = 5, Bottom = 5 };
                        newNodeAction.Font = new System.Drawing.Font("Arial Unicode MS", 8.5F, System.Drawing.FontStyle.Regular);
                        newNodeAction.Brush = decisionBrush;
                        if (from == 0)
                        {
                            newNodeAction.Text =
                                HttpUtility.HtmlDecode(ddlTreeType == 0
                                    ? lstByGrouping[0].Questions
                                    : lstByGrouping[0].QuestionNode);
                            //newNodeAction.Text = "Q-" + lstByGrouping[0].QuestionID.ToString();
                            newNodeAction.ToolTip = lstByGrouping[0].Questions;
                        }
                        else
                        {
                            newNodeAction.Text =
                                HttpUtility.HtmlDecode(ddlTreeType == 0
                                    ? lstByGrouping[0].Questions
                                    : lstByGrouping[0].QuestionID.ToString());
                            //.Length > 15 ? lstByGrouping[0].Questions.ToString().Substring(0, 15) : lstByGrouping[0].Questions.ToString();
                            newNodeAction.ToolTip = HttpUtility.HtmlDecode(lstByGrouping[0].Questions);
                        }

                        // newNodeAction.Locked = true;
                        if (newNodeAction.Text.Trim().Length > 75)
                            newNodeAction.Text =
                                HttpUtility.HtmlDecode(newNodeAction.Text.Substring(0, 75) + "...");
                        newNodeAction.Tag = lstByGrouping[0].QuestionID + "" +
                                            lstByGrouping[0].QuestionIDRoot + "PD" + lstByGrouping[0].ParentDecision;
                        allDiagramList.Add(new DiagramList
                        {
                            NodeTag = newNodeAction.Tag.ToString(),
                            QuestionIDRoot = lstByGrouping[0].QuestionIDRoot,
                            QuestionID = lstByGrouping[0].QuestionID,
                            DecisionParent = lstByGrouping[0].ParentDecision,
                            RNo = allDiagramList.Count()
                        });
                    }

                    // var item = disItem;
                    foreach (var item in lstByGrouping)
                    {
                        if (!allDiagramList.Exists(
                            x =>
                                x.AnswerID == item.AnswerID && x.QuestionIDRoot == item.QuestionIDRoot &&
                                x.PrvQuestionID == parentID && x.DecisionParent == item.ParentDecision))
                        {
                            var newNodeAns = diagramView.Diagram.Factory.CreateShapeNode(0, 0,
                                ddlTreeType == 0 ? 30 : 20, 10);
                            newNodeAns.Shape = Shapes.DividedProcess;
                            newNodeAns.Font = new System.Drawing.Font("Arial Unicode MS", 8.5F, System.Drawing.FontStyle.Regular);
                            newNodeAns.Brush = normalBrush;
                            if (from == 0)
                            {
                                newNodeAns.Text = HttpUtility.HtmlDecode(ddlTreeType == 0 ? item.Title : item.AnswerNode);
                                //  newNodeAns.Locked = true;
                                newNodeAns.ToolTip =
                                    HttpUtility.HtmlDecode(item.Title +
                                                           ((item.Justification == 1 || item.Justification == 2)
                                                               ? (Environment.NewLine +
                                                                  "Justification" + ":" +
                                                                  Convert.ToString(item.JustificationRemark))
                                                               : ""));
                            }
                            else
                            {
                                newNodeAns.Text =
                                    HttpUtility.HtmlDecode(ddlTreeType == 0
                                        ? "a" + "-" + item.AnswerID + " : " +
                                          item.Title
                                        : "a" + "-" + item.AnswerID);
                                newNodeAns.ToolTip =
                                    HttpUtility.HtmlDecode("a" + "-" +
                                                           item.AnswerID + " : " + item.Title +
                                                           ((item.Justification == 1 || item.Justification == 2)
                                                               ? (Environment.NewLine +
                                                                  "Justification" + ":" +
                                                                  Convert.ToString(item.JustificationRemark))
                                                               : ""));
                            }
                            newNodeAns.Tag = item.AnswerID + "a" + "" +
                                             item.QuestionID + "" +//+"Q" + "" +
                                             item.QuestionIDRoot + "PD" + item.ParentDecision;

                            if (newNodeAns.Text.Trim().Length > 30)
                                newNodeAns.Text =
                                    HttpUtility.HtmlDecode(newNodeAns.Text.Substring(0, 30) + "...");

                            allDiagramList.Add(new DiagramList
                            {
                                NodeTag = newNodeAns.Tag.ToString(),
                                QuestionIDRoot = item.QuestionIDRoot,
                                DecisionParent = item.ParentDecision,
                                PrvQuestionID = parentID,
                                AnswerID = item.AnswerID,
                                RNo = allDiagramList.Count()
                            });
                            link = diagramView.Diagram.Factory.CreateDiagramLink(newNode, newNodeAns);

                            SetLikStyle(link, item.IsConduct == 1 ? 1 : 0);

                            switch (decisionType)
                            {
                                case 4:
                                    //case (int)Utility.DecisionTypes.ValidationStandardAssessment:
                                    //case 7:

                                    link = diagramView.Diagram.Factory.CreateDiagramLink(newNodeAns, newNodeAction);
                                    SetLikStyle(link, item.IsConduct == 1 ? 1 : 0);
                                    if (version == 0)
                                    {
                                        if (indexScore != 0)
                                        {
                                            link.Text ="Score" + " : " + item.IndexScore;
                                        }
                                    }
                                    else
                                    {
                                        link.Text ="Score" + " : " + item.IndexScore;
                                    }
                                    break;
                               
                            }
                        }
                    }

                    if (lstQuestionAction.Any(x => x.QuestionIDRoot == rootID && x.PrvQuestionID != 0))
                        lstQuestionAction.Where(
                            x =>
                                x.QuestionIDRoot == rootID && x.PrvQuestionID == parentID &&
                                x.ParentDecision == parentID + "-" + parentDecision)
                            .ToList()
                            .ForEach(x => { x.NodeStatus = 1; });
                    else
                        lstQuestionAction.Where(x => x.QuestionIDRoot == rootID)
                            .ToList()
                            .ForEach(x => { x.NodeStatus = 1; });


                    var ChildDecisionRoot = 0;
                    if (
                        lstQuestionAction.Any(
                            x => x.QuestionIDRoot == disItem.QuestionID && x.PrvQuestionID == disItem.QuestionIDRoot))
                    // && x.ParentDecision == disItem.ParentDecision
                    {
                        ChildDecisionRoot = disItem.QuestionIDRoot;
                    }

                    if (
                        lstQuestionAction.Any(
                            x => x.QuestionIDRoot == disItem.QuestionID && x.PrvQuestionID == ChildDecisionRoot))
                    {
                        LoadFusionChild(disItem.QuestionID, ChildDecisionRoot, disItem.ParentDecision, lstQuestionAction,
                            newNodeAction, normalBrush, decisionBrush, from, indexScore, version);
                    }
                    else if (disItem.QuestionID == 0)
                    {
                        var endNode = diagramView.Diagram.Factory.CreateShapeNode(0, 0, ddlTreeType == 0 ? 30 : 20, 10);
                        endNode.Brush = terminalBrush;
                        endNode.Font = new Font("Arial Unicode MS", 8.5F, FontStyle.Regular);
                        endNode.Pen = terminalPen;
                        endNode.Text = "End"; // "END";                        
                        endNode.Tag = disItem.QuestionID + "_" + indx + "End";
                        indx++;
                        endNode.Shape = Shapes.Ellipse;
                        // endNode.Locked = true;
                        //   lstRules.Add(ScoreValue);
                        arrList.Add(endNode);
                        link = diagramView.Diagram.Factory.CreateDiagramLink(newNodeAction, endNode);
                        SetLikStyle(link, lstByGrouping[0].IsConduct == 1 ? 1 : 0);

                        //link.Brush = new MindFusion.Drawing.SolidBrush(Color.Green);
                    }

                }
                else
                {
                    var lstByGrouping =
                        lstQuestionAction.Where(
                            x =>
                                x.QuestionIDRoot == disItem.QuestionIDRoot && x.QuestionID == disItem.QuestionID &&
                                x.PrvQuestionID == parentID && x.ParentDecision == disItem.ParentDecision).ToList();


                    foreach (var item in lstByGrouping)
                    {
                        if (!allDiagramList.Exists(
                            x =>
                                x.AnswerID == item.AnswerID && x.QuestionIDRoot == item.QuestionIDRoot &&
                                x.PrvQuestionID == parentID && x.DecisionParent == item.ParentDecision))
                        {
                            var newNodeAns = diagramView.Diagram.Factory.CreateShapeNode(0, 0,
                                ddlTreeType == 0 ? 30 : 20, 10);
                            newNodeAns.Shape = Shapes.DividedProcess;
                            newNodeAns.Font = new Font("Arial Unicode MS", 8.5F, FontStyle.Regular);
                            newNodeAns.Brush = normalBrush;
                            if (from == 0)
                            {
                                newNodeAns.Text = HttpUtility.HtmlDecode(ddlTreeType == 0 ? item.Title : item.AnswerNode);
                                newNodeAns.ToolTip =
                                    HttpUtility.HtmlDecode(item.Title +
                                                           ((item.Justification == 1 || item.Justification == 2)
                                                               ? (Environment.NewLine +
                                                                  "Justification" + ":" +
                                                                  Convert.ToString(item.JustificationRemark))
                                                               : ""));
                            }
                            else
                            {
                                newNodeAns.Text =
                                    HttpUtility.HtmlDecode(ddlTreeType == 0
                                        ? "a" + "-" + item.AnswerID + " : " +
                                          item.Title
                                        : "a" + "-" + item.AnswerID);
                                newNodeAns.ToolTip =
                                    HttpUtility.HtmlDecode("a" + "-" +
                                                           item.AnswerID + " : " + item.Title +
                                                           ((item.Justification == 1 || item.Justification == 2)
                                                               ? (Environment.NewLine +
                                                                  "Justification" + ":" +
                                                                  Convert.ToString(item.JustificationRemark))
                                                               : ""));
                            }

                            if (newNodeAns.Text.Trim().Length > 30)
                                newNodeAns.Text = newNodeAns.Text.Substring(0, 30) + "...";
                            //  newNodeAns.Locked = true;

                            newNodeAns.Tag = item.AnswerID + "a" + item.QuestionID +
                                             item.QuestionIDRoot + "PD" + item.ParentDecision;
                            allDiagramList.Add(new DiagramList
                            {
                                NodeTag = newNodeAns.Tag.ToString(),
                                QuestionIDRoot = item.QuestionIDRoot,
                                DecisionParent = item.ParentDecision,
                                PrvQuestionID = parentID,
                                AnswerID = item.AnswerID,
                                RNo = allDiagramList.Count()
                            });
                            link = diagramView.Diagram.Factory.CreateDiagramLink(newNode, newNodeAns);
                            SetLikStyle(link, item.IsConduct == 1 ? 1 : 0);

                            var endNode = diagramView.Diagram.Factory.CreateShapeNode(0, 0, ddlTreeType == 0 ? 30 : 20,
                                10);
                            endNode.Brush = terminalBrush;
                            endNode.Font = new Font("Arial Unicode MS", 8.5F,
                                FontStyle.Regular);
                            endNode.Pen = terminalPen;
                            endNode.Text = "End"; // "END";                            
                            endNode.Tag = disItem.QuestionID.ToString() + "_" + indx.ToString() + "End" + item.AnswerID.ToString();
                            indx++;
                            endNode.Shape = Shapes.Ellipse;
                            //  endNode.Locked = true;
                            arrList.Add(endNode);
                            switch (decisionType)
                            {
                                case 4:
                                    //case (int)Utility.DecisionTypes.ValidationStandardAssessment:
                                    //case 7:

                                    link = diagramView.Diagram.Factory.CreateDiagramLink(newNodeAns, endNode);
                                    SetLikStyle(link, item.IsConduct == 1 ? 1 : 0);
                                    if (version == 0)
                                    {
                                        if (indexScore != 0)
                                        {
                                            link.Text ="Score" + " : " + item.IndexScore;
                                        }
                                    }
                                    else
                                    {
                                        link.Text ="Score" + " : " + item.IndexScore;
                                    }
                                    break;
                                
                            }
                        }
                    }
                }
            }
        }
        #endregion
        
        /// <summary>
        /// Arrange Decision Diagram
        /// </summary>
        /// <param name="allDList"></param>
        private void Arrange(List<DiagramList> allDList)
        {
            var arrage = "start";
            if (hdnArragePosition != -1)
            {
                if (Convert.ToInt32(hdnArragePosition) != 0 && Convert.ToInt32(hdnArragePosition) < allDList.Count())
                {
                    arrage = allDList[Convert.ToInt32(hdnArragePosition)].NodeTag;
                    hdnArragePosition = hdnArragePosition + 1;
                }
                else if (allDList.Count == Convert.ToInt32(hdnArragePosition))
                {
                    hdnArragePosition = 0;
                }
                else
                    hdnArragePosition = hdnArragePosition + 1;
            }
            var layout = new MindFusion.Diagramming.Layout.DecisionLayout
            {
                HorizontalPadding = 10,
                VerticalPadding = 10,
                StartNode = diagramView.Diagram.FindNode(arrage)
            };
            layout.Arrange(diagramView.Diagram);
            diagramView.Diagram.ResizeToFitItems(5);
        }

        public void SetLikStyle(DiagramLink link, int Flag)
        {
            if (Flag == 1)
            {
                //link.Brush = linkCuruntPathBrush;
                //link.HeadShapeSize = 4f;

                link.Brush = linkCuruntPathBrush;//new MindFusion.Drawing.SolidBrush(Color.FromArgb(0, 151, 3)); //linkCuruntPathBrush;
                link.ShadowBrush = new MindFusion.Drawing.SolidBrush(Color.GreenYellow);//.FromArgb(72, 157, 52)); //new MindFusion.Drawing.SolidBrush(Color.Green);
                link.ShadowOffsetX = .8f;
                link.ShadowOffsetY = .8f;

                link.HeadShapeSize = 5f;
            }
            else
            {
                link.Brush = linkNormalBrush;
                link.HeadShapeSize = 4f;
            }
        }
        
        private MindFusion.Diagramming.WebForms.DiagramView SetTableFont(MindFusion.Diagramming.WebForms.DiagramView diagramView1)
        {
            foreach (var table in diagramView1.Diagram.Nodes.OfType<TableNode>())
                table.Font = new Font("Arial Unicode MS", 8);

            return diagramView1;
        }
        [Serializable]
        public class DiagramList
        {

            public string NodeTag { get; set; }

            public int QuestionID { get; set; }

            public int AnswerID { get; set; }

            public int QuestionIDRoot { get; set; }

            public int RNo { get; set; }

            public int PrvQuestionID { get; set; }

            public string DecisionParent { get; set; }
        }

    #region Entity
    [Serializable]
    public class DecisionTree
    {

        public int DecisionVersion { get; set; }
        public int DecisionID { get; set; }

        public string Scope { get; set; }

        public string Description { get; set; }

        public string Prefix { get; set; }

        public int DecisionType { get; set; }

        public string DecisionTypeName { get; set; }

        public int CreatedBy { get; set; }

        public int SiteID { get; set; }

        public long TimeStamp { get; set; }

        public int ID { get; set; }

        public string Title { get; set; }
        /// <summary>
        /// column for Append the title and code
        /// </summary>
        public string DecisionTitle { get; set; }

        public string GuID { get; set; }

        public int QuestionID { get; set; }

        public int AnswerID { get; set; }

        public string Questions { get; set; }
        public string Answers { get; set; }
        public string RiskFactorTitle { get; set; }
        public string RiskValueTitle { get; set; }
        public string QnUniqueID { get; set; }

        public int IndexScore { get; set; }

        public int QuestionIDRoot { get; set; }

        public string QuestionsRoot { get; set; }

        public List<DecisionTreeAnswers> lstAnswers { get; set; }

        public List<DecisionTree> lstSavedQuestions { get; set; }

        public int SectionID { get; set; }

        public int SectionNo { get; set; }

        public List<DecisionTree> lstDecisionSection { get; set; }

        public int RunningQuestionID { get; set; }

        public int RunningQuestionIDRoot { get; set; }

        public int RunningAnswerID { get; set; }

        public List<DecisionTree> lstQuestionAction { get; set; }

        public int FromRange { get; set; }

        public int ToRange { get; set; }

        public int ActionID { get; set; }

        public int Condition { get; set; }

        public List<DecisionTree> lstAssementRule { get; set; }

        public string xmlString { get; set; }

        public int Flag { get; set; }

        public int Step { get; set; }

        public List<DecisionTree> lstDeliverables { get; set; }

        public int EsignReason { get; set; }

        public int Status { get; set; }

        public DateTime CreatedOn { get; set; }

        public string SortExpression { get; set; }

        public string SearchString { get; set; }

        public int MaxQuestionID { get; set; }

        public int MaxAnswerID { get; set; }

        public int Complete { get; set; }

        public string Reason { get; set; }

        public int Version { get; set; }
        public int LanguageId { get; set; }

        public string DecisionCode { get; set; }

        public string DecVersion { get; set; }

        public int ContentGenerationTypeID { get; set; }

        public string UserName { get; set; }

        public DecisionTree DecisionData { get; set; }

        public int NodeStatus { get; set; }

        public int SameActionRequired { get; set; }

        public int RemoveFlag { get; set; }

        public int PrvQuestionID { get; set; }

        public int RunningPrvQuestionID { get; set; }

        public int ActionQuestionID { get; set; }

        public string ParentDecision { get; set; }

        public List<DecisionTree> lstParentDecison { get; set; }

        public string CommonDecisionID { get; set; }

        public int DecisionActionID { get; set; }

        public int PrvDecisionActionID { get; set; }

        public int ActionSetID { get; set; }

        public int IsConduct { get; set; }

        public string HelpText { get; set; }

        public string QuestionRootNode { get; set; }

        public string QuestionNode { get; set; }

        public string AnswerNode { get; set; }

        public int Justification { get; set; }

        public string JustificationRemark { get; set; }
        #region Property
        /// <summary>
        /// Gets or sets Attachments
        /// </summary>
        public string Attachments { get; set; }
        #endregion
        public int QuestionCount { get; set; }
        /// <summary>
        /// Gets Or Sets ClientOffset
        /// </summary>
        public string ClientOffset { get; set; }

        /// <summary>
        /// Gets or Sets ClientZone
        /// </summary>
        public string ClientZone { get; set; }
        /// <summary>
        /// Default property for UTCCompletedOn
        /// </summary>
        private DateTime _utcCompletedOn;
        /// <summary>
        ///  Gets or Sets UTCCompletedOn
        /// </summary>
        public DateTime UTCCompletedOn
        {
            get
            {
                return _utcCompletedOn;
            }
            set
            {
                _utcCompletedOn = value;
            }

        }

        public string TFGroupDocId { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public int RiskTypeID { get; set; }
        /// <summary>
        /// Default Property for Schedule that gets or sets the Frequency for Schedule.
        /// </summary>
        public int Frequency { get; set; } //Added

        /// <summary>
        /// Default Property for Schedule that gets or sets the Frequency Type for Schedule
        /// </summary>
        public int FrequencyType { get; set; } //Added
        public string Direction { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public List<DecisionYesNoDetails> lstDecisionYesNoDetails { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public List<DecisionTree> lstDecisionYesNoValReq { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public List<DecisionTree> lstDecisionYesNoValNotReq { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public string SectionType { get; set; }
        public int DecisionAction { get; set; }
        public int RuleSetID { get; set; }
        public int RuleOrderID { get; set; }
        public int ConditionReq { get; set; }
        public int AssessmentDecisionType { get; set; }
        public int ResultID { get; set; }
        public int RiskValue { get; set; }
        public int RiskObjectID { get; set; }
        public string RiskScore { get; set; }
        public string SystemSectionValue { get; set; }
        public string RiskModelName { get; set; }
        private bool _isRemove = true;
        public bool IsRemove
        {
            get { return _isRemove; }
            set { _isRemove = value; }
        }
        public List<DecisionTree> lstAssementBusinessRules { get; set; }
    }

    [Serializable]
    public class DecisionTreeAnswers
    {
        public int ID { get; set; }

        public int RunningQuestionID { get; set; }

        public int QuestionID { get; set; }

        public string Questions { get; set; }

        public int AnswerID { get; set; }

        public int RunningAnswerID { get; set; }

        public string Title { get; set; }
        public string Prefix { get; set; }

        public int Justification { get; set; }

    }

    [Serializable]
    public class DecisionTreeMapping
    {
        public int ID { get; set; }

        public int QuestionID { get; set; }

        public string Questions { get; set; }

        public int AnswerID { get; set; }

        public string Title { get; set; }

    }

    [Serializable]
    public class DecisionTreeScore
    {
        public int No { get; set; }
    }
    [Serializable]
    public class DecisionTreeview
    {
        public string DecID { get; set; }
        public string DecLevel { get; set; }
        public string Parent { get; set; }
        public string Title { get; set; }
        public string QuestionType { get; set; }
        public int OrderId { get; set; }
        public int Iteraltion { get; set; }
        public string IndexScore { get; set; }
        public string Deliverables { get; set; }
        public string Regulation { get; set; }
        public int DecType { get; set; }
        public string GenTest { get; set; }
        public string EntTest { get; set; }
        public int labelId { get; set; }
        public int Connector { get; set; }

    }

    [Serializable]
    public class DecisionTreeDeliverables
    {
        public string DelivType { get; set; }
        public string DelivTypeName { get; set; }
    }

    [Serializable]
    public class DecisionYesNoDetails
    {
        public int RunningQuestionID { get; set; }

        public int QuestionID { get; set; }

        public int DetailID { get; set; }

        public int ResultID { get; set; }

        public int AnswerID { get; set; }

        public int RunningAnswerID { get; set; }

        public int Status { get; set; }

        public string SystemSectionValue { get; set; }

        public string SystemSectionText { get; set; }

        public int SystemSectionID { get; set; }

        public int RiskValue { get; set; }

        public int RiskTypeID { get; set; }

        public string Question { get; set; }

        public string Answer { get; set; }
    }
    #endregion Entity

}